;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Document name: cfit.pro
; Created by:    Philip Judge, March 28, 2004
;
; Last Modified: Wed May 24 11:38:37 2006 by judge (judge) on macniwot.local
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
FUNCTION cfit,nn,fit,plot = plot,parms = parms
;
@cdiper
COMMON therm,temp,tot
COMMON files,lu
;
z = lvl(0).ion
o0 = fit(0)*fit(0)*fit(0)*100./z
o1 = fit(1)*fit(1)*fit(1)*100./z
o2 = fit(2)*fit(2)*fit(2)*100./z
;
;  energy range half way between first/last excited states
;
mx = max(lvl.ev)
;mn = ev(0)
;e0 = mn  + (mx-mn)*fit(3)/3.
;e1 = mn  + (mx-mn)/3. + (mx-mn)*fit(4)/3.
;e2 = mn  +(mx-mn)*2./3. + (mx-mn)*fit(5)/3.
;
e0 = fit(3)*mx
e1 = fit(4)*mx
e2 = fit(5)*mx
;
ff = 8.63e-06*(o0/sqrt(temp)*exp(-e0*ee/bk/temp)*e0*ee + $
               o1/sqrt(temp)*exp(-e1*ee/bk/temp)*e1*ee + $
               o2/sqrt(temp)*exp(-e2*ee/bk/temp)*e2*ee )
lff = alog10(ff)
lto = alog10(tot)
cfit = total((lff-lto)*(lff-lto))/n_elements(lff)
cfit = 1./sqrt(cfit)
IF(n_elements(plot) NE 0) THEN BEGIN
   oplot,temp,ff,lines = 2
;   print,atomid
;   print,'Omega 0 Omega 1 Omega 2             E0    E1    E2'
;   print,o0,o1,o2,e0,e1,e2
;   print,'chi^2=',1./cfit
;   print,fit
   parms = [o0,o1,o2,e0,e1,e2,1./cfit]
ENDIF
;
return,cfit
END


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; End of 'cfit.pro'.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
